//
//  920MHz LoRa/FSK RF module ES920LR3 
//
//  MaiaR create
//


#include "LoRa.h"

int rxPin = 9; // PC1;
int txPin = 8; // PC0;

void LoRaReset(){
  Serial1.end();
  pinMode(rxPin, OUTPUT);
  pinMode(txPin, OUTPUT);
  digitalWrite(rxPin, LOW);
  digitalWrite(txPin, LOW);
  delay(1000);
  pinMode(rxPin, INPUT);
  pinMode(txPin, INPUT);
}


void LoRaConfigMode(){
  String rx;
  Serial.begin(115200);
  
  while(1){
    LoRaReset();
    Serial1.begin(115200);
    Serial1.setTimeout(50);
    delay(50);
    rx = Serial1.readString();
    Serial.println(rx);
    if (rx.indexOf("Select Mode") >= 0) break;
    LoRaCommand("config");
  }
}


int LoRaCommand(String s){
  String rx;
  Serial1.print(s);
  Serial1.print("\r\n");
  Serial1.flush();
  Serial.println(s);
  delay(10);
  rx = Serial1.readString();
  Serial.print(rx);
  return (rx.indexOf("OK"));
}


int LoRaInit(){
  LoRaConfigMode();
  if (LoRaCommand("2"     ) < 0) return(-1); // processor mode
  if (LoRaCommand("x"     ) < 0) return(-1); // default
  if (LoRaCommand("c 12"  ) < 0) return(-1); // spread factor
  if (LoRaCommand("d 3"   ) < 0) return(-1); // channel
  if (LoRaCommand("e 2345") < 0) return(-1); // PAN ID
  if (LoRaCommand("f 0"   ) < 0) return(-1); // own ID
  if (LoRaCommand("g ffff") < 0) return(-1); // broadcast
  if (LoRaCommand("p 1"   ) < 0) return(-1); // RSSI on
  if (LoRaCommand("z"     ) < 0) return(-1); // start
  return(0);
}
